<template>
  <div>
    <!-- We don't use "rui-form" here as it's not suitable for this form -->
    <form action="#" class="gpa-map-form" @submit.prevent="save">
      <div class="-grid-1-2 -gap">
        <div>
          <rui-errors :errors="errors" model="map" />

          <fieldset>
            <legend>{{ $t('js.maps.form.groups.general') }}</legend>
            <rui-field input-id="map_name" :label="$t('activerecord.attributes.map.name')">
              <input id="map_name"
                     v-model="inputs.name"
                     type="text"
                     name="name"
                     :placeholder="$t('js.maps.form.name_placeholder')"
                     required>
            </rui-field>

            <rui-field :help="$t('js.maps.form.publicly_available_help')">
              <label for="map_publicly_available">
                <input id="map_publicly_available"
                       v-model="inputs.publicly_available"
                       type="checkbox"
                       name="publicly_available">
                {{ $t('activerecord.attributes.map.publicly_available') }}
              </label>
            </rui-field>
          </fieldset>

          <fieldset v-show="currentStep >= STEPS_ORDER.PICTURE_SELECTION" class="-mtd">
            <legend>{{ $t('js.maps.form.groups.background') }}</legend>
            <rui-field input-id="map-picture" :label="$t('js.maps.form.select_picture')">
              <input id="map-picture"
                     type="file"
                     :accept="acceptedMimeTypes"
                     :disabled="currentStep > STEPS_ORDER.PICTURE_SELECTION"
                     required
                     @change="renderMap">
            </rui-field>

            <div class="-mtd">
              <rui-field>
                <label for="map_toggle_background">
                  <input id="map_toggle_background" type="checkbox" :checked="inputs.background_color" @change="toggleBackgroundColor">
                  {{ $t('js.maps.form.custom_background_color') }}
                </label>
              </rui-field>

              <rui-field>
                <label :class="{'-text--color--mute': !inputs.background_color}">
                  {{ $t('js.maps.form.pick_color') }}
                  <input v-model="inputs.background_color" type="color" :disabled="!inputs.background_color">
                </label>
              </rui-field>
            </div>
          </fieldset>

          <fieldset v-show="currentStep >= STEPS_ORDER.SETTING_SCALE" class="-mtd">
            <legend>{{ $t('js.maps.form.groups.map_scaling') }}</legend>
            <rui-alert variant="info">
              {{ $t('js.maps.form.scale_help') }}
              <ol>
                <li>{{ $t('js.maps.form.scale_help_step_1') }}</li>
                <li>{{ $t('js.maps.form.scale_help_step_2') }}</li>
              </ol>
            </rui-alert>
            <rui-field input-id="map-scale-reference" :label="$t('js.maps.form.scale_reference')" append="m">
              <input id="map-scale-reference"
                     v-model="scaleReference"
                     name="scale"
                     type="number"
                     class="-text--right"
                     :disabled="currentStep > STEPS_ORDER.SETTING_SCALE">
            </rui-field>
          </fieldset>

          <fieldset v-show="currentStep >= STEPS_ORDER.SETTING_CENTER" class="-mtd">
            <legend>{{ $t('js.maps.form.groups.center_definition') }}</legend>
            <rui-alert variant="info">{{ $t('js.maps.form.select_center_note') }}</rui-alert>
          </fieldset>

          <div class="-text--right -mtd">
            <rui-button v-if="currentStep < STEPS.length - 1"
                        :caption="$t('js.generic.next')"
                        variant="creative"
                        :disabled="!canStartNextStep"
                        @click="next" />
            <rui-submit-button v-else :loading="loading" :caption="$t('js.maps.form.save_this_map')" :disabled="!inputs.center" />
          </div>
        </div>

        <div id="map" class="gpa-map-form__map" :style="mapStyle" />
      </div>
    </form>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiSubmitButton from '@experiments-labs/rise_ui/src/components/Inputs/SubmitButton/SubmitButton.vue'

import MapEditionMixin from '../mixins/MapEdition'

// Step name and methods to execute when changing
const STEPS = [
  {
    name: 'GENERAL_INFO',
    validate (inputs) { return inputs.name.length > 0 },
    entering () {},
  },
  {
    name: 'PICTURE_SELECTION',
    validate (inputs) { return inputs.picture !== null },
    entering () {},
  },
  {
    name: 'SETTING_SCALE',
    validate (inputs) { return inputs.extent_height !== null },
    entering (context) {
      context.enterMeasureMode()
    },
  },
  {
    name: 'SETTING_CENTER',
    validate (inputs) { return inputs.center !== null },
    entering (context) {
      context.enterCenterSelectionMode()
    },
  },
]

const STEPS_ORDER = {}
STEPS.forEach((value, index) => { STEPS_ORDER[value.name] = index })

export default {
  name: 'GpaNewPictureMapForm',
  components: { RuiSubmitButton, RuiButton, RuiAlert, RuiField, RuiErrors },
  mixins: [MapEditionMixin],
  data () {
    return {
      acceptedMimeTypes: MAPS_ALLOWED_MIME_TYPES,
      inputs: {
        name: '',
        publicly_available: false,
        ...this.defaultMapInputs(),
      },
      scaleReference: 0,

      // Form
      loading: false,
      errors: null,
      STEPS_ORDER,
      STEPS,
      currentStep: 0,
    }
  },
  computed: {
    mapStyle () {
      if (!this.inputs.background_color) return ''

      return `background-color: ${this.inputs.background_color}; background-image: none;`
    },
    canStartNextStep () { return STEPS[this.currentStep].validate(this.inputs) },
  },
  methods: {
    toggleBackgroundColor () { this.inputs.background_color = this.inputs.background_color ? null : '#000000' },
    defaultMapInputs () {
      return {
        picture: null,
        center: null,
        extent_width: null,
        extent_height: null,
        background_color: null,
      }
    },
    reset () {
      this.resetMap()
      this.resetState()
      const inputs = this.defaultMapInputs()
      Object.keys(inputs).forEach(k => { this.inputs[k] = inputs[k] })
    },
    next () {
      this.currentStep += 1
      STEPS[this.currentStep].entering(this)
    },
    save () {
      const payload = { ...this.inputs }
      this.errors = null
      this.loading = true
      this.$store.dispatch('createMap', payload)
        .then((map) => {
          this.$router.push({ name: 'map', params: { mapId: map.id } })
        })
        .catch(error => { this.errors = error })
        .then(() => { this.loading = false })
    },
    renderMap (event) {
      const files = event.target.files || event.dataTransfer.files
      const file = files[0]
      const extension = file.name.split('.').pop().toLowerCase()

      // FIXME: This should use the list defined in instance configuration
      if (!['png', 'jpg', 'jpeg', 'svg'].includes(extension)) {
        throw new Error(`${extension} is not a supported file format`)
      }

      this.reset()
      this.inputs.picture = file

      const reader = new FileReader()
      this.loadAndRenderMap(reader)
      reader.readAsDataURL(file)
    },
  },
}
</script>

<style lang="scss" src="./MapForm.scss" />
